package com.zhongzheng.modules.course.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.course.bo.TeacherAddBo;
import com.zhongzheng.modules.course.bo.TeacherEditBo;
import com.zhongzheng.modules.course.bo.TeacherQueryBo;
import com.zhongzheng.modules.course.domain.Teacher;
import com.zhongzheng.modules.course.mapper.TeacherMapper;
import com.zhongzheng.modules.course.service.ITeacherService;
import com.zhongzheng.modules.course.vo.TeacherVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;


import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 名师Service业务层处理
 *
 * @author hjl
 * @date 2021-05-19
 */
@Service
public class TeacherServiceImpl extends ServiceImpl<TeacherMapper, Teacher> implements ITeacherService {

    @Override
    public TeacherVo queryById(Long teacherId){
        Teacher db = this.baseMapper.selectById(teacherId);
        return BeanUtil.toBean(db, TeacherVo.class);
    }

    @Override
    public List<TeacherVo> queryList(TeacherQueryBo bo) {
        LambdaQueryWrapper<Teacher> lqw = Wrappers.lambdaQuery();
        lqw.like(StrUtil.isNotBlank(bo.getTeacherName()), Teacher::getTeacherName, bo.getTeacherName());
        lqw.in(bo.getStatus() != null, Teacher::getStatus, bo.getStatus());
        lqw.in(bo.getTeacherIds() != null, Teacher::getTeacherId, bo.getTeacherIds());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<TeacherVo> entity2Vo(Collection<Teacher> collection) {
        List<TeacherVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, TeacherVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<Teacher> page = (Page<Teacher>)collection;
            Page<TeacherVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(TeacherAddBo bo) {
        Teacher add = BeanUtil.toBean(bo, Teacher.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(TeacherEditBo bo) {
        Teacher update = BeanUtil.toBean(bo, Teacher.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(Teacher entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
